
module bios_rom 
(
    input clk,              		// clock signal

	output reg	[12:0] bios_addr,
    output reg 	[7:0] dout,   		// 8-bit data bus (output)

	//output 			bios_loaded,

    input 			   ioctl_download,
    input 			   ioctl_wr,
    input 		[24:0] ioctl_addr,
    input 		[ 7:0] ioctl_dout   
);

reg [15:0] bios_tmp[64];
reg [15:0] bios_din;
reg        bios_wr = 0;
wire       bios_req;
reg        bios_loaded = 0;

always @(posedge clk) begin
	reg       bios_reqD;
	reg       ioctl_downlD;

	ioctl_downlD <= ioctl_download;
	if (ioctl_download & ~ioctl_downlD) begin
		bios_addr <= 0;
		bios_wr <= 0;
	end

	if (ioctl_downlD & ~ioctl_download) bios_loaded <= 1;

	if (ioctl_download & ioctl_wr) begin
		if (ioctl_addr[0]) begin
			bios_tmp[ioctl_addr[6:1]] <= {ioctl_dout, dout};
			if (&ioctl_addr[5:1]) bios_wr <= 1;
		end else begin
			dout <= ioctl_dout;
		end
	end

	bios_reqD <= bios_req;
	if (bios_reqD & ~bios_req) bios_wr <= 0;

	if (ioctl_download & bios_req) begin
		bios_addr <= bios_addr + 1'd1;
		bios_din <= bios_tmp[bios_addr[5:0]];
	end
end

endmodule
